*! Tim Morris   2015
* Simulation for generating IP data and AD from IP datasets

program define gendata , rclass
	version 13
	syntax , [	///
		nstudies(integer 40) ///
    nmean(real 3.798) ///
		nsd(real 1.104) ///
		randprop(real .5)	///
		beta(real 0)	///
		tau(real 0)	///
		sigma(real 1)	///
		]

	tempvar studyre sigmavar ni

* Generate AD datasets from IPD
	set obs `nstudies' // set obs to largest no. studies considered (analysis lines say which studies are included)
	gen byte study = _n
	if (`tau' > 0) {
		gen `studyre' = rnormal(0,`tau')
		gen `sigmavar' = (`sigma'*50)/rchi2(50)
	}
	else {
		gen `studyre' = 0
		gen `sigmavar' = `sigma'
	}
	gen int `ni' = exp(rnormal(`nmean',`nsd')) // size of study, following Rucker et al.
		replace `ni' = 20 if `ni' < 20
	expand `ni'
	bysort study: gen int j = _n
	gen byte trt = rbinomial(1,`randprop')	// simulate simple randomisation
	gen byte trtbystud = trt*study if trt == 1
	replace trtbystud = (trt-1)*study if trt == 0
	gen y = ((`beta'+`studyre')*trt) + rnormal(0,`sigma')	// simulate outcome

end
